#include "typedef.h"

#ifndef CODE_H_
#define CODE_H_

#define ADD_T 1
#define SUB_T 2
#define MULT_T 3 
#define COMP_T 4
#define SLT_T 5
#define ASS_T 6
#define SRT_T 7
#define CONST_T 8
#define REG_T 9
#define FLOW_T 10
#define MEMVAR_T 11
#define MEMCON_T 12
#define VAR_T   13
#define CALL_T  14
#define SYSCALL_T 15
#define IF_T     16
#define WHILE_T  17
#define RETURN_T 18
#define DIV_T    19
#define OR_T    20
#define AND_T    21
#define NUM_PAR  22
#define NUM_IDE  23
#define NEXTFUNC 24
#define FUNC_T   25
#define SMALLER_T   26
#define GREATER_T   27
#define EQUAL_T   28
#define NEQUAL_T   29
#define NOT_T   30
#define MEMVAR_BYTE_T 31
#define MEMADDR_T 32


typedef struct s_node {
	int		op;
	long 		value;
	int 		regNr;
        char          * name;
        struct s_node * params;
        tsymbol       * decls;

	int 		label;
	struct s_node *	left;
	struct s_node *	right;
} treenode;

typedef treenode *treenodep;

#define NODEPTR_TYPE	treenodep
#define OP_LABEL(p)	((p)->op)
#define LEFT_CHILD(p)	((p)->left)
#define RIGHT_CHILD(p)	((p)->right)
#define STATE_LABEL(p)	((p)->label)
#define PANIC		printf

#endif
