%{
#include <math.h>
#include "y.tab.h"
#include <string.h>
#include "typedef.h"
#include "code.h"
#include <stdio.h>
extern int line;
%}


BUCH        [A-Za-z]
ZIFF        [0-9]
IDENT       ({BUCH}|"_")({BUCH}|{ZIFF}|"_")*     
NUM         "-"?{ZIFF}+
HEX         [0-9a-fA-F]
HEXNUM      [0][x]{HEX}+
WS          [ \t] 
RT          [\n]
SHL         [<][<]
SHR         [>][>]
SLASH       [/]
KOMMENTAR   {SLASH}{SLASH}.*
%%
void   	    return VOID;
long        return LONG;
float       return FLOAT;
or          return OR;
and         return AND;
extern      return EXTERN;
syscall     return SYSCALL;
if          return IF;
while       return WHILE;
return      return RETURN;
byte	    return BYTE;
{NUM}       return NUM; @{ @NUM.value@ = atol(yytext); @} 
{HEXNUM}       return NUM; @{ sscanf(yytext, "%x",&@NUM.value@); @}
{IDENT}     return IDENT;  @{ @IDENT.name@ = strcpy((char*) malloc(sizeof(strlen(yytext))+1),yytext); @} 
{SHL}       return SHIFTL;
{SHR}       return SHIFTR;
"\("        return '(';
"\)"        return ')';
"\<"        return '<';
"\>"        return '>';
"!="        return NEQUAL;
"=="        return EQUAL;
"!"         return NOT;
"\="        return '=';
"\["        return '[';
"\]"        return ']';
"\{"        return '{';
"\}"        return '}';
"\+"        return '+';
"\-"        return '-';
"\*"        return '*';
"\/"        return '/';
"\;"        return ';';
"\,"        return ',';
"\&"	    return '&';
{KOMMENTAR} ;
\n	    {line++; }
{WS}        ;
.	    {ECHO; fprintf(stderr,"Unknown token %s in line %d!\n",yytext, line); exit(1);};

